--  _          _ _         _   _                     
-- | |__   ___| | | ___   | |_| |__   ___ _ __ ___   
-- | '_ \ / _ \ | |/ _ \  | __| '_ \ / _ \ '__/ _ \  
-- | | | |  __/ | | (_) | | |_| | | |  __/ | |  __/_ 
-- |_| |_|\___|_|_|\___/   \__|_| |_|\___|_|  \___(_)
--
-- Did you miss me?
--
-- This is a port of HORNMOD to Dr. Robotnik's Ring Racers.
-- As such, this may have bugs!

-- Erm, what?
rawset(_G, "HORNMOD", "RR.1")
print("\142HORNMOD v"..HORNMOD.." - locked and loaded!")

-- cache shit as per usual
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local BT_VOTE = (1<<7) -- why is this not exposed
local ANG12 = ANG10 + ANG2
local MF2_SHADOW = MF2_SHADOW
local MF2_DONTDRAW = MF2_DONTDRAW

local horn_debug = CV_RegisterVar({
	name = "horn_debug",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local horn_hellchance = CV_RegisterVar({
	name = "horn_hellchance",
	defaultvalue = "5",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local horn_preferexpansions = CV_RegisterVar({
	name = "horn_preferexpansions",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local horn_antispam = CV_RegisterVar({
	name = "horn_explode",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local horn_volumelimit = CV_RegisterVar({
	name = "horn_volumelimit",
	defaultvalue = "255",
	flags = 0,
	possiblevalue = {MIN = 0, MAX = 255}
})
local horn_unleashhell = CV_RegisterVar({
	name = "horn_unleashhell",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CALL,
	possiblevalue = CV_OnOff,
	func = function()
		for p in players.iterate
			if p.hornmod and p.hornmod.selection then
				p.hornmod.selection = 0
				CONS_Printf(p, "Sua horn foi resetada pois o host mudou as configuracoes.")
			end
			if p.hornmod and p.hornmod.faves then
				p.hornmod.faves = nil
				CONS_Printf(p, "Suas favoritas foram resetadas pois o host mudou as configuracoes.")
			end
		end
	end
})

-- our table is broken
local horns = {}
local hellhorns = {}
local muted = false
local baseonly = true
local horncount_horns = 0
local horncount_hellhorns = 0

rawset(_G, "HORNMOD_Horns", function()
	return horns
end)
rawset(_G, "HORNMOD_HellHorns", function()
	return hellhorns
end)

local function dprint(...)
	if not horn_debug.value then return end
	local fug = "\132[HORNMOD]\128 "
	if leveltime then fug = $ + "\132(" + leveltime + ")\128 " end
	if not ... then
		fug = $ + "Did you seriously pass NOTHING to a debug print?"
	else
		fug = $ + table.concat({...}, " ")
	end
	CONS_Printf(server, fug)
end

-- RR already includes S_HORNCODE so no need to include MT_HAHALOUD 
freeslot("sfx_hmwarn")
freeslot("sfx_hmdang")
freeslot("sfx_hmslct")
freeslot("sfx_hmhell")
freeslot("sfx_hmstop") -- unused FOR NOW...

addHook("MobjThinker", function(mo)
	if not (mo.target and mo.target.valid and mo.target.player) then
		P_RemoveMobj(mo)
	end
end, MT_HORNCODE)

addHook("MobjThinker", function(mo)
	-- follower horn, ignore everything
	if not (mo and mo.valid and mo.target and mo.target.valid and mo.target.player and mo.target.player.valid) then
		return
	end
	
	local pmo = mo.target
	local hm = pmo.player.hornmod

	local hofs = pmo.height*2 - FRACUNIT*8*2
	if pmo.eflags & MFE_VERTICALFLIP then
		hofs = FRACUNIT*8*2
	end

	mo.eflags = ($ & ~MFE_VERTICALFLIP) | (pmo.eflags & MFE_VERTICALFLIP)
	mo.color = pmo.color
	mo.spriteyoffset = pmo.spriteyoffset
	mo.scale = FixedMul(pmo.scale, FRACUNIT + min(hm.shake/256, FRACUNIT)) -- encourage spamming
	if hm.flash then
		mo.color = SKINCOLOR_YELLOW
		mo.scale = FixedMul($, 11*FRACUNIT/10)
	end
	
	local shake = min(hm.shake/2, 15*FRACUNIT)

	-- PRNG since visual won't update if a client can't see it, meaning real randomness desyncs
	P_MoveOrigin(mo,
		pmo.x + FixedMul(N_Random()/FRACUNIT, shake),
		pmo.y + FixedMul(N_Random()/FRACUNIT, shake),
		pmo.z + hofs + FixedMul(N_Random()/FRACUNIT, shake) + sin(leveltime * ANG12) - FRACUNIT/2)
	return true
end, MT_HORNCODE)

-- Okay, this is a little bit of a hack, but I came up with the schema while delirious from illness so I know it's a good idea.
-- Basically, filtering tables sucks, updating tables sucks, all that.
-- But because we have a limited number of places that actually need to set the horn, just faking the table size is somewhat sustainable.
-- If a horn index is past the maximum number of normal horns, it's a hell horn: for instance, with 200 base horns, horn #202 is hellhorn #2.
-- Here are a few wrappers that make this hack less stupid.
-- (I swear, it's actually less complicated and more performant than doing this "correctly"!)
local function hellcount()
	if horn_unleashhell.value then return horncount_horns + horncount_hellhorns end
	return horncount_horns
end

-- planning to port multihorns eventually but not now
local function get_horn(x, p)
	if x > horncount_horns then return hellhorns[x - horncount_horns] end
	return horns[x]
end

local function prettyhornname(h, p, cm)
	p = p or nil
	if h > horncount_horns then
		return "\134#" .. h .. ": \133" .. get_horn(h, p).info
	else
		return "\135#" .. h .. ": \130" .. get_horn(h, p).info
	end
end
local function hornsoff(p, ...)
	p.hornmod = $ or {}
	p.hornmod.muted = true
	if p == consoleplayer then
		muted = true
	end
	CONS_Printf(p, "\131OK! \128Voce nao ira escutar nem mandar horns. Use \130hornson\128 se voce mudar de ideia.")
end
COM_AddCommand("hornsoff", hornsoff)
local function hornsoff(p, ...)
	p.hornmod = $ or {}
	p.hornmod.muted = false
	if p == consoleplayer then
		muted = false
	end
	CONS_Printf(p, "\131OK! \128Voce ira escutar e mandar horns novamente. Bem-vindo devolta!")
end
COM_AddCommand("hornson", hornsoff)

local function shutup(p, target) -- Significantly reduce horn annoyance from a target player.
	if p != consoleplayer then return end -- this should only run locally.
	if not target then
		CONS_Printf(p, "Especifique um jogador que esteja te encomodando, como \130shutup Sapo\128.")
		return
	end
	local acc = 0
	local loudidiot = nil
	if tonumber(target) != nil then
		loudidiot = players[tonumber(target)] -- thanks, terminal!
	else
		target = $:lower()
		for p in players.iterate
			if p.name:lower():match(target) then
				acc = $ + 1
				loudidiot = p
			end
		end
	end
	if loudidiot == nil then
		CONS_Printf(p, "Nenhum jogador com esse nome / numero existe, digitou errado?")
		return
	end
	if acc > 1 then
		CONS_Printf(p, "Isso se aplica a mais de um jogador. Seja mais especifico!")
		return
	end
	if not loudidiot.hornmod.muffled then -- yeah the condition is backwards, what about it
		loudidiot.hornmod.muffled = true
		CONS_Printf(p, "\131OK! \128Horns de "..loudidiot.name.." serao bem, bem mais baixas.")
		CONS_Printf(p, "Para desfazer isso, use o mesmo comando novamente.")
	else
		loudidiot.hornmod.muffled = false
		CONS_Printf(p, "\131OK! \128Voce ouvira as horns de "..loudidiot.name.." novamente.")
	end
end
COM_AddCommand("shutup", shutup)
local function hornlist(p, i)
	local guard = tonumber(i) or 1
	local rangehelp = ""
	local pagesize = 20
	local adjust = 0
	local total = hellcount()
	if total % pagesize then
		adjust = 1
	end
	if guard < 0 or guard > (total / pagesize + adjust) then
		guard = 1
		rangehelp = " \134(numero de pagina ignorado, fora de alcance)"
	end
	local pagedivider = "\134=== Pagina \130" .. guard .. " \134de \130" .. (total/pagesize + adjust) .. " \134===" .. rangehelp
	guard = $ - 1
	local lowbound = guard * pagesize + 1
	local highbound = min(total, guard * pagesize + pagesize)
	CONS_Printf(p, pagedivider)
	for h = lowbound, highbound do
		CONS_Printf(p, prettyhornname(h, p))
	end
	CONS_Printf(p, pagedivider)
	CONS_Printf(p, "Experimente usar \131listhorns \130[pagina]\128, \131sethorn \130[numero] \128ou \131sethorn \130[palavra]\128.")
end
COM_AddCommand("listhorns", hornlist)
local function sethorn(p, ...)
	p.hornmod = $ or {}
	local packedargs = {...}
	if #packedargs == 0 then
		CONS_Printf(p, "* \131(Tentando \130listhorns\131...)")
		hornlist(p, 1)
		return
	end
	local guard = nil
	if #packedargs == 1 then
		guard = tonumber(packedargs[1])
	end
	if guard == nil or #packedargs > 1 then -- no direct number match, let's try a fuzzy search
		local searchstring = table.concat(packedargs, " "):lower()
		local hits = {}
		for k, v in ipairs(horns)
			if string.find(v.info:lower(), searchstring, 0, true) or (v.extags and string.find(v.extags:lower(), searchstring, 0, true)) then
				table.insert(hits, k)
			end
		end
		if horn_unleashhell.value then
			for k, v in ipairs(hellhorns) -- :GOD:
				if string.find(v.info:lower(), searchstring, 0, true) or (v.extags and string.find(v.extags:lower(), searchstring, 0, true)) then
					table.insert(hits, k + #horns)
				end
			end
		end
		if #hits > 1 then
			for k, v in ipairs(hits) do
				CONS_Printf(p, prettyhornname(v, p))
			end
			CONS_Printf(p, "\133Varias horns conferem \135" .. searchstring .. "\133. \128Poderia ser mais especifico?")
			return
		elseif #hits == 0 then
			CONS_Printf(p, "\133Nenhuma horn confere \135" .. searchstring .. "\133. \128Digitou errado?")
			return
		else
			guard = hits[1]
		end
	end
	if guard == 0 then
		p.hornmod.selection = 0
		S_StartSound(nil, sfx_hmslct, p)
		CONS_Printf(p, "\131OK! \128Preferencia de horn limpada. Sua proxima horn sera aleatoria.")
		return
	elseif guard < 1 or guard > hellcount() then
		CONS_Printf(p, "\133Fora de alcance. \128Tente um numero entre 1 e " .. hellcount() .. ", ou use \135listhorns\128.")
		return
	end
	p.hornmod.selection = guard
	S_StartSound(nil, _G[get_horn(guard).name], p)
	S_StartSound(nil, sfx_hmslct, p)
	CONS_Printf(p, "\131OK! \128Sua horn sera " .. prettyhornname(guard, p) .. "\128 para a proxima corrida.\nUse \135resethorn\128 para usar horns aleatorias novamente.")
end
COM_AddCommand("sethorn", sethorn)
-- helper provided for backcompat
local function resethorn(p, ...)
	sethorn(p, 0)
end
COM_AddCommand("resethorn", resethorn)
-- expert mode / horn testing
local function adjusthorn(p, target)
	p.hornmod = $ or {}
	if target == "random" then
		p.hornmod.selection = P_RandomRange(1, hellcount())
	else
		local guard = tonumber(target)
		if not guard or guard > #horns then
			CONS_Printf(p, "Why")
			return
		end
		if (not p.hornmod.selection) or p.hornmod.selection < 1 then
			p.hornmod.selection = 1
		else
			p.hornmod.selection = (($ + target + hellcount()) % hellcount()) or hellcount()
		end
	end
	S_StartSound(nil, _G[get_horn(p.hornmod.selection).name], p)
	CONS_Printf(p, prettyhornname(p.hornmod.selection, p))
end
COM_AddCommand("adjusthorn", adjusthorn)
local function strsplit(s, delimiter)
    local result = {}
    for match in (s..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match)
    end
    return result
end
-- helper provided for backcompat
local function favehorn(p, ...)
	p.hornmod = $ or {}
	local hm = p.hornmod
	local packedargs = {...}
	if #packedargs < 1 then
		CONS_Printf(p, "Especifique varias horns. Enquanto voce nao tiver outra horn escolhida, voce ira alternar entre as favoritas.\nExemplo: \130favehorn 11 28 33-42 114")
		CONS_Printf(p, "Use \130favehorn reset\128 para limpar suas horns favoritas e habilitar todas as outras.")
		return
	end
	if #packedargs == 1 and (packedargs[1] == "0" or packedargs[1] == "reset") then
		CONS_Printf(p, "Suas horns favoritas foram limpadas.")
		return
	end
	local tfaves = {}
	for i = 1, #packedargs
		local arg = packedargs[i]
		local guard = tonumber(arg)
		if guard then -- number
			if guard > hellcount() or guard < 1 then
				CONS_Printf(p, "Got confused when reading this segment (out of range): \130"..arg)
				return
			end
			table.insert(tfaves, guard)
		else -- try argparse
			local args = strsplit(arg, "-")
			if #args == 2 then
				local lbound = tonumber(args[1])
				local ubound = tonumber(args[2])
				if not (lbound and ubound) then
					CONS_Printf(p, "Got confused when reading this segment (not numbers): \130"..arg)
					return
				end
				if lbound < 1 or ubound > hellcount() or lbound > ubound then
					CONS_Printf(p, "Got confused when reading this segment (pair out of range): \130"..arg)
					return
				end
				for j = lbound, ubound
					table.insert(tfaves, j)
				end
			else
				CONS_Printf(p, "Got confused when reading this segment (wrong args): \130"..arg)
				return
			end
		end
	end
	p.hornmod.faves = tfaves
	CONS_Printf(p, "\131OK! \128Suas horns favoritas foram selecionadas. Essas serao usadas quando nao tiver mais nada selecionado.")
end
COM_AddCommand("favehorn", favehorn)
-- helper provided for backcompat
local function horn(p, ...)
	if ... then
		CONS_Printf(p, "* \131(Tentando \130sethorn "..table.concat({...}, " ").."\131...)")
		sethorn(p, ...)
		return
	end
	p.hornmod = $ or {}
	local hm = p.hornmod
	-- ugly begins here
	if not hm.selectedcm then
		if hm.horn then
			CONS_Printf(p, "Horn atual:  "..prettyhornname(hm.horn, p))
		else
			CONS_Printf(p, "Horn atual:  \130Nenhuma!")
		end
		if hm.cselection then
			CONS_Printf(p, "Horn selecionada:  "..prettyhornname(hm.cselection, p, (hm.cselection > 0)))
		elseif hm.selection then
			CONS_Printf(p, "Horn selecionada: "..prettyhornname(hm.selection, p))
		else
			CONS_Printf(p, "Horn selecionada: \130Nenhuma!")
		end
		if hm.faves then
			local fug = hm.faves
			CONS_Printf(p, "Horns favoritas: \130"..#fug.." selecionadas")
		else
			CONS_Printf(p, "Horns favoritas: \130Nenhuma!")
		end
	else
		CONS_Printf(p, "Horn atual:  "..prettyhornname(hm.selectedcmhorn, p, (hm.selectedcmhorn > 0)))
		if hm.cselection then
			CONS_Printf(p, "Horn selecionada:  "..prettyhornname(hm.cselection, p, (hm.cselection > 0)))
		elseif hm.selection then
			CONS_Printf(p, "Horn selecionada: "..prettyhornname(hm.selection, p))
		else
			CONS_Printf(p, "Horn selecionada: \130Nenhuma!")
		end
		if hm.faves then
			local fug = hm.faves
			CONS_Printf(p, "Horns favoritas: \130"..#fug.." selected")
		else
			CONS_Printf(p, "Horns favoritas: \130Nenhuma!")
		end
	end
	CONS_Printf(p, " ")
	CONS_Printf(p, "Comandos: \130listhorns\128, \130sethorn\128, \130keephorn\128, \130resethorn\128, \130favehorn\128, \130hornson\128, \130hornsoff\128, \130shutup\128, \130horn_volumelimit")
end
COM_AddCommand("horn", horn)
local function keephorn(p, ...)
	p.hornmod = $ or {}
	local hm = p.hornmod
	if hm.horn then
		if hm.horn > hellcount() then
			CONS_Printf(p, "Voce nao pode escolher uma hellhorn. BOA TENTATIVA!")
		else
			S_StartSound(nil, _G[get_horn(hm.horn).name], p)
			S_StartSound(nil, sfx_hmslct, p)
			CONS_Printf(p, "\131OK!\128 Voce ira usar "..prettyhornname(hm.horn, p).." a partir de agora.")
			hm.selection = hm.horn
		end
	else
		CONS_Printf(p, "Voce nao tem uma horn escolhida ainda!")
	end
end
COM_AddCommand("keephorn", keephorn)

-- actual stuff herere
local function allocatenewhorn(name, supress_warning)
	if not _G[name] then
		freeslot(name)
		sfxinfo[_G[name]].flags = SF_X4AWAYSOUND
	elseif supress_warning == false then
		print(name .. " already allocated, distance flag will be wrong!")
	end
end
local function hm_hellcondition(p)
	local mo = p.mo
	local ks = p.kartstuff
	local hm = p.hornmod
	local hellmap = ((P_RandomRange(1, 1000) <= horn_hellchance.value))
	
	if leveltime ~= 2*TICRATE then return false end
	if hm.selection then return false
	elseif not hellmap then return false end
	return true
end

local function selectHorn(hm, p)
	if hm.faves and (not hm.selection) then
		hm.horn = hm.faves[P_RandomRange(1, #hm.faves)]
	else
		repeat
			hm.horn = P_RandomRange(1, hellcount())
		until not (horn_preferexpansions.value and get_horn(hm.horn, p).base)
	end
end

local function selectHellHorn(hm, p)
	repeat
		hm.horn = horncount_horns + P_RandomRange(1, horncount_hellhorns)
	until not (horn_preferexpansions.value and get_horn(hm.horn, p).base)
end

local function selectRandomHorn(hm, p)
	repeat
		hm.horn = P_RandomRange(1, horncount_horns)
	until not (horn_preferexpansions.value and get_horn(hm.horn, p).base)
end

local function initPlayer(hm)
	hm.exploded = false
	hm.postracetimer = 0
	hm.horninput = 0
	hm.hornduration = 0
	hm.hornplaying = false
	hm.sincelasthorn = 0
	hm.horncount = 0
	hm.shake = 0
	hm.flash = 0
	hm.warnstate = 0
	hm.hmconfig = $ or 0
	hm.lasthorn = nil
	hm.helled = false
end

local function removeOrigin(hm)
	if hm.origin then
		dprint("Removing origin")
		if hm.origin.valid then P_RemoveMobj(hm.origin) end
		hm.origin = nil
	end
	if hm.visual then
		dprint("Removing visual")
		if hm.visual.valid then P_RemoveMobj(hm.visual) end
		hm.visual = nil
		hm.hornplaying = false
	end
end

-- runs before MapLoad
addHook("PlayerSpawn", function(p)
	-- new joiner?
	if not p.hornmod then
		p.hornmod = {}
		initPlayer(p.hornmod)
		p.nethornenabled = not p.hornmod.muted
		-- gotta find consoleplayer because SPLITSCREEEEEEEEN
		if p.splitscreenindex > 0 then
			dprint(p.name, "is looking for their consoleplayer...")
			for px in players.iterate do
				if px.jointime == p.jointime and px.splitscreenindex == 0 then
					dprint("Found", px.name)
					p.hornmod.splitscreenmaster = px
					break
				end
			end
		end
	end
	removeOrigin(p.hornmod)
end)

local hellmap, playhellsound

-- reset everyone at race start
addHook("MapLoad", function()
	hellmap = mapheaderinfo[gamemap].menuflags & LF2_HIDEINMENU
	playhellsound = true -- for splitscreen
	for p in players.iterate do
		initPlayer(p.hornmod)
		selectHorn(p.hornmod)
		p.nethornenabled = not p.hornmod.muted
	end
end)

addHook("PlayerSpawn", function(p)
	if horncount_horns == 0 then return end
	if not (p and p.valid) then return end
	local mo = p.mo
	local ks = p.kartstuff
	local hm = p.hornmod
	if hm.storedhorn then
		hm.horn = hm.storedhorn
	end
	hm.storedhorn = nil
end)

addHook("PlayerThink", function(p)
	if leveltime == 0 or horncount_horns== 0 then return end -- leveltime 0 is cursed and runs 3 times.
	
	local mo = p.mo
	local hm = p.hornmod

	-- rr changes made me do leveltime == 2 lmao
	if hm.selection and (leveltime == 2 or leveltime < starttime or p.spectator) and not hm.helled then
		hm.horn = hm.selection
	end

	if not mo or (p.playerstate == PST_DEAD) then
		removeOrigin(hm)
		return
	end -- active players only below this line
	
	-- can't do it in PlayerSpawn because RNG is unsafe there during replays
	if not hm.horn then
		selectHorn(p.hornmod)
	end
	
	-- can't spawn mobjs in the PlayerSpawn hook either, or else replays crash the game
	if not hm.origin then
		dprint("Spawning origin for", p.name)
		hm.origin = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
		hm.origin.state = S_INVISIBLE
		hm.origin.tics = -1
		hm.origin.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
	end
	
	-- assign hellhorns in the middle of prerace for that extra feeling of slight panic
	-- doesn't nicely format a message for multiple displayplayers getting hellhorns,
	-- but this is already WAAAAY overkill
	if leveltime == 2*TICRATE
	and not (horn_unleashhell.value)
	and hm_hellcondition(p) then
		if not muted then
			local name = "your"
			for dp in displayplayers.iterate do
				if dp == p then -- that's me!
					if splitscreen > 0 then
						name = hellmap and "everyone's" or dp.name.."'s"
					end
					if not (hellmap and not playhellsound) then -- print once for map hell
						chatprintf(consoleplayer, "\x83*Uma sombra passa pelo botao de item de "..name..".")
					end
					if playhellsound then
						S_StartSound(nil, sfx_hmhell, consoleplayer)
						playhellsound = false
					end
				end
			end
		end
		hm.helled = true
		selectHellHorn(hm)
	end

	-- remind players that hornmod exists and how to work it, i guess
	if p.exiting or (p.lives == 0) then
		hm.postracetimer = $ + 1
		if hm.postracetimer == 2*TICRATE then
			if hm.horn and (not hm.muted) and  (not (hm.selection or hm.faves)) then
				local sel = hm.horn
				CONS_Printf(p, "Sua horn nessa corrida: "..prettyhornname(sel, p, nil))
			end
			if not hm.tutorial then
				chatprintf(p, "\x83*Use o comando \130horn\x83 no console para informacoes. Use \130shutup (nome do jogador)\x83 se a pessoa estiver barulhenta. (Essa mensagem e exibida apenas uma vez.)", true)
				hm.tutorial = true
			end
		end
	end
		
	-- assign hellhorns in the middle of prerace for that extra feeling of slight panic
	if leveltime == 2*TICRATE then 	
		if hm_hellcondition(p) and not horn_unleashhell.value then
			S_StartSound(nil, sfx_hmhell, p)
			chatprintf(p, "\x83*Uma sombra passa no seu botao de item ...")
			p.hornmod.horn = horncount_horns + P_RandomRange(1, horncount_hellhorns)
		end
	end
	
	// sound stuff
	local hornsound = _G[get_horn(hm.horn, p).name]
	local hornvolume = 255
	
	-- shutup
	if hm.muffled then hornvolume = 50 end

	-- HORN THINKER --

	P_MoveOrigin(hm.origin, mo.x, mo.y, mo.z) -- moveorigin the origin
	
	-- draw only if the sound is actually playing, meaning no visuals while muted
	-- (this also affects players with -noaudio)
	hm.shake = max(0, $ - ($/8))
	if hm.hornplaying then
		--print(hm.horn)
		if S_SoundPlaying(hm.origin, hornsound) or (hm.lasthorn and S_SoundPlaying(hm.origin, hm.lasthorn)) then
			hm.hornduration = $ + 1
			hm.playpenalty = $ + 3

			if not hm.visual then
				dprint("Spawning visual for", p.name)
				local hofs = mo.height*2 - FRACUNIT*8
				if mo.eflags & MFE_VERTICALFLIP then
					hofs = FRACUNIT*8
				end
				hm.visual = P_SpawnMobj(mo.x, mo.y, mo.z + hofs, MT_HORNCODE)
				hm.visual.colorized = true
				hm.visual.target = mo
				hm.visual.color = mo.color
				-- let's allow shutup'd players to still communicate, but in a less annoying way
				if hm.muffled then hm.visual.flags2 = $ | MF2_SHADOW end
			end

			-- hellhorns just get angrier as they continue playing
			if hm.horn > horncount_horns then
				hm.shake = max($, hm.hornduration*FRACUNIT/2)
			end
			
			hm.flash = max($ - 1, 0)
		else
			if hm.visual then
				dprint("Removing visual for", p.name)
				P_RemoveMobj(hm.visual)
				hm.visual = nil
			end
			hm.hornplaying = false
			hm.hornduration = 0
		end
	end
	
	if horn_antispam.value then
		-- have you been too loud? then it's time to die
		-- we gate this behind no spinout and grounded—no using it to cheese
		-- could check against spbposition as well, but handling that case is kinda wacky...
		-- ...and if you can time a horn explosion to avoid the SPB, IMO you've kinda earned it
		if hm.warnstate == 3
		and P_IsObjectOnGround(mo)
		and p.spinouttimer == 0 then
			-- trying to explode for attention? no thanks.
			if hm.exploded then
				S_StartSound(p.mo, sfx_kc3b)
				-- your loss.
				P_DamageMobj(p.mo, p.mo, nil, 999, DMG_TUMBLE)
				p.mo.momz = $ + (32*FRACUNIT * P_MobjFlip(p.mo))
				-- i do not see it
				p.mo.hitlag = 0
				p.tumblebounces = 3
			else
				-- but yeah fucking die lmao
				P_KillMobj(p.mo, nil, nil)
			end
			-- if hitfeed then HF_SendHitMessage({{nil, nil}, {nil, nil}, nil}, {{p.name, p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}, "K_HORNHF", p.skincolor) end
			hm.exploded = true
			hm.horncount = 0
			hm.warnstate = 0
			return -- don't need to play any horns
		end

		-- reset if they haven't touched the horn for a few seconds.
		if hm.warnstate > 0 and hm.warnstate < 3 and hm.sincelasthorn > 5*TICRATE then
			hm.horncount = 0
			hm.warnstate = 0
		end
		hm.sincelasthorn = $ + 1
	end
	
	-- are we pressing horn? and are we able to horn?
	-- fun fact, rr changed the custom buttons to "lua" buttons
	-- no idea why
	hm.horninput = (p.cmd.buttons & BT_VOTE) and $ + 1 or 0
	
	-- look, we want bots to horn
	if p.bot then
		-- they will only attempt to horn at 10 tick intervals....
		if leveltime % 30 == 0 then
			-- ....roll a 24-side die and attempt to horn or not.
			-- this totally wont get annoying
			if P_RandomRange(0, 24) == 0 then hm.horninput = $ + 1 end
		end
	end
	
	-- we honkin baby
	if hm.horninput == 1 then
		// way too many checks
		if (p.exiting) or (p.deadtimer > 1) or 
			(not hm.muted) then
			hm.flash = 2 -- yellow flash for a little extra impact
			
			-- should we be doing spam calculations? if you're under a powerup or in 1v1, you're immune.
			if horn_antispam.value then
				if leveltime > starttime
				and not (p.growshrinktimer > 0)
				and (not p.invincibilitytimer) then
					-- a small amount of uncertainty makes the spam warning more forboding
					hm.horncount = $ + 1 + (leveltime & 1)
					-- spamming horns slowly means more total time spent playing noises
					-- this is basically a discount on rapid mashing, since it's not actually that disruptive
					if hm.sincelasthorn >= TICRATE/2 then
						hm.horncount = $ + 2
					end
					hm.sincelasthorn = 0
					hm.warnanim = 10 -- pulses the spam warning text
					
					-- warnstate tracks what level of warning the player knows they're under
					-- at warnstate 3, you die!

					-- cues for various levels of warnstate
					if hm.horncount > 39 and hm.warnstate == 2 then
						hm.warnstate = 3
					elseif hm.horncount > 26 and hm.warnstate == 1 then
						hm.warnstate = 2
						S_StartSoundAtVolume(nil, sfx_hmdang, 255, p)
						S_StartSoundAtVolume(nil, sfx_s3k50, 160, p)
					elseif hm.horncount > 13 and (not hm.warnstate) then
						hm.warnstate = 1
						S_StartSoundAtVolume(nil, sfx_hmwarn, 255, p)
						S_StartSoundAtVolume(nil, sfx_s3kb2, 160, p)
					end
				end
			end
			
			-- don't play if muted
			-- do it here or else replays desync
			if (hm.muted and not replayplayback) or muted then return end
			
			local displayplayer
			for dp in displayplayers.iterate do
				if dp == p then displayplayer = p end
			end

			-- step 2: play the rest of the fucking horn
			if leveltime > starttime
			or p == displayplayer then
				hm.flash = 2 -- yellow flash for a little extra impact
				hm.shake = $ + 10*FRACUNIT -- and a little bit of extra sauce for the visual
				hm.hornplaying = true
				hm.playpenalty = $ or 0
				S_StopSound(hm.origin)
				if p == displayplayer then
					S_StartSoundAtVolume(hm.origin, hornsound, 255) -- sneaky...always hear your own horns at max volume
				elseif horn_antispam.value then
					S_StartSoundAtVolume(hm.origin, hornsound, hornvolume)
					-- resets after 15 seconds
					elseif hm.sincelasthorn >= 15*TICRATE then
						hm.sincelasthorn = 0
						hm.playpenalty = 0
						S_StartSoundAtVolume(hm.origin, hornsound, hornvolume)
				else
					S_StartSoundAtVolume(hm.origin, hornsound, max(hornvolume - hm.playpenalty/3, horn_volumelimit.value))
				end
			end
		end
	end

	-- update next frame's item information
	hm.lastitem = p.itemtype
	hm.lastheld = p.bananadrag
	hm.lastsneaker = p.k_rocketsneakertimer
end)

rawset(_G, "HORNMOD_AddHorns", function(...) -- expects same format as the horn table up top
	local packedargs = {...}
	for k, v in ipairs(packedargs) do
		allocatenewhorn(v.name, false)
		table.insert(horns, v)
		horncount_horns = $ + 1
		print("HORNMOD: Added " .. v.name)
		-- oh yeah, let's make sure the script knows preferexpansions will work
		if not v.base then baseonly = false end
	end
end)
rawset(_G, "HORNMOD_AddHellHorns", function(...)
	local packedargs = {...}
	for k, v in ipairs(packedargs) do
		v.hell = true
		allocatenewhorn(v.name, false)
		freeslot(v.name)
		horncount_hellhorns = $ + 1
		table.insert(hellhorns, v)
		print("HORNMOD: Added " .. v.name)
	end
end)


-- to add a multihorn, look at example in basehorns.lua
-- you can specify a custom order, by default it just goes linearly
-- set random = 1 in your horn to enable random order
-- when using random, you can use the order to set weights
rawset(_G, "HORNMOD_AddMultiHorns", function(...)
	print("HORNMOD: Unimplemented!")
end)
hud.add(function(v, p, c)
	if not p.hornmod then return end
	local hm = p.hornmod
	if hm.warnstate then
		local warnings = {"\130RELAXA NESSAS HORNS AI!", "\133EU PEDI EDUCADAMENTE!!", "\133HORA DE MORRER!!!"}
		local flags = 0
		-- pulse when player does bad things
		if not (hm.warnanim % 2) then flags = V_50TRANS end
		v.drawString(160, 30, warnings[hm.warnstate], flags, "center")
	end
end)